config/routes.rb
Rails.application.routes.draw do
  resources :contacts
  
  post 'check_emails' => "contacts#check_emails"
  post 'delete_all' => "contacts#delete_all"
  post 'download_all' => "contacts#download_all"
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/contact.rb
require 'csv'
class Contact < ApplicationRecord
  before_create :email_check

  def email_check
    bool = nil
    begin
      bool = EmailVerifier.check(email)
    rescue EmailVerifier::NoMailServerException
      bool = false
    rescue EmailVerifier::NoMailServerException
      bool = false
    rescue
      bool = nil
    end
    self.is_valid = bool
  end

  def self.to_csv(path=nil)
    _csv = CSV.generate do |csv|
      csv << column_names
      all.each do |result|
        csv << result.attributes.values_at(*column_names)
      end
    end
    if path
      File.open(path, 'w') do |f|
        f.write(_csv)
      end
    end
    _csv
  end

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

app/controllers/contacts_controller.rb
class ContactsController < ApplicationController
  before_action :set_contact, only: [:show, :edit, :update, :destroy]

  # GET /contacts
  # GET /contacts.json
  def index
    @contacts = Contact.all
  end

  # GET /contacts/1
  # GET /contacts/1.json
  def show
  end

  # GET /contacts/new
  def new
    @contact = Contact.new
  end

  # GET /contacts/1/edit
  def edit
  end

  # POST /contacts
  # POST /contacts.json
  def create
    @contact = Contact.new(contact_params)

    respond_to do |format|
      if @contact.save
        format.html { redirect_to @contact, notice: 'Contact was successfully created.' }
        format.json { render :show, status: :created, location: @contact }
      else
        format.html { render :new }
        format.json { render json: @contact.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /contacts/1
  # PATCH/PUT /contacts/1.json
  def update
    respond_to do |format|
      if @contact.update(contact_params)
        format.html { redirect_to @contact, notice: 'Contact was successfully updated.' }
        format.json { render :show, status: :ok, location: @contact }
      else
        format.html { render :edit }
        format.json { render json: @contact.errors, status: :unprocessable_entity }
      end
    end
  end

  def delete_all
    Contact.delete_all if params["message"] == "delete"
    redirect_to request.referrer
  end

  # DELETE /contacts/1
  # DELETE /contacts/1.json
  def destroy
    @contact.destroy
    respond_to do |format|
      format.html { redirect_to contacts_url, notice: 'Contact was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  def download_all
    send_data Contact.to_csv, filename: "#{DateTime.now}-#{Contact.count}-emails_check.csv"
  end

  def check_emails
    if (params["message"].split("\n\r").length > 1)
      params["message"].split("\n\r").each do |email|
        Contact.find_by(email: email) || Contact.create(email: email)
      end
    elsif (params["message"].split("\r\n").length > 1)
      params["message"].split("\r\n").each do |email|
        Contact.find_by(email: email) || Contact.create(email: email)
      end
    elsif (params["message"].split("\n").length > 1)
      params["message"].split("\n").each do |email|
        Contact.find_by(email: email) || Contact.create(email: email)
      end
    elsif (params["message"].split("\r").length > 1)
      params["message"].split("\r").each do |email|
        Contact.find_by(email: email) || Contact.create(email: email)
      end
    else
      Contact.find_by(email: params["message"])
    end
    redirect_to request.referrer
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_contact
      @contact = Contact.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def contact_params
      params.require(:contact).permit(:email, :is_valid)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/contacts_helper.rb
module ContactsHelper
end

app/views/contacts/_form.html.erb
<%= form_with(model: contact, local: true) do |form| %>
  <% if contact.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(contact.errors.count, "error") %> prohibited this contact from being saved:</h2>

      <ul>
      <% contact.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :email %>
    <%= form.text_field :email, id: :contact_email %>
  </div>

  <div class="field">
    <%= form.label :is_valid %>
    <%= form.check_box :is_valid, id: :contact_is_valid %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/contacts/edit.html.erb
<h1>Editing Contact</h1>

<%= render 'form', contact: @contact %>

<%= link_to 'Show', @contact %> |
<%= link_to 'Back', contacts_path %>

app/views/contacts/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Contacts</h1>

<h5> Please check <a href="https://www.spamhaus.org/query/ip/51.15.205.197" target="blank">https://www.spamhaus.org/query/ip/51.15.205.197</a> to see if this ip is still clean</h5>
<br>
<br>
<h5> enter ONLY email adresses below (copy from csv) </h1>
<form accept-charset="UTF-8" action="/check_emails" method="post">
  <input name="utf8" type="hidden" value="&#x2713;" />
  <input name="authenticity_token" type="hidden" value="J7CBxfHalt49OSHp27hblqK20c9PgwJ108nDHX/8Cts=" />
  <%= text_area_tag(:message, "test@diduenjoy.com\ntest2@example.com", size: "24x6") %>
  <%= submit_tag("check_emails") %>
</form>

<br>

<form accept-charset="UTF-8" action="/delete_all" method="post">
  <input name="utf8" type="hidden" value="&#x2713;" />
  <input name="authenticity_token" type="hidden" value="J7CBxfHalt49OSHp27hblqK20c9PgwJ108nDHX/8Cts=" />
  <%= text_field_tag(:message, "tap 'delete' and press the button ", size: "24x6") %>
  <%= submit_tag("DELETE ALL CARE") %>
</form>


<br>
<br>

<h4>export <%= @contacts.size %> as csv</h4>
<form accept-charset="UTF-8" action="/download_all" method="post">
  <input name="utf8" type="hidden" value="&#x2713;" />
  <input name="authenticity_token" type="hidden" value="J7CBxfHalt49OSHp27hblqK20c9PgwJ108nDHX/8Cts=" />
  <%= submit_tag("export as csv") %>
</form>




<table>
  <thead>
    <tr>
      <th>Email</th>
      <th>Is valid</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @contacts.each do |contact| %>
      <tr>
        <td><%= contact.email %></td>
        <td><%= contact.is_valid %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Contact', new_contact_path %>

app/views/contacts/new.html.erb
<h1>New Contact</h1>

<%= render 'form', contact: @contact %>

<%= link_to 'Back', contacts_path %>

app/views/contacts/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Email:</strong>
  <%= @contact.email %>
</p>

<p>
  <strong>Is valid:</strong>
  <%= @contact.is_valid %>
</p>

<%= link_to 'Edit', edit_contact_path(@contact) %> |
<%= link_to 'Back', contacts_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Mailchecker</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>

     <!-- Compiled and minified CSS -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0-alpha.2/css/materialize.min.css">

    <!-- Compiled and minified JavaScript -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0-alpha.2/js/materialize.min.js"></script>

  </head>

  <body>
    <%= yield %>
  </body>
</html>